; 
    include \masm32\include\masm32rt.inc
; 

IDC_EDIT equ 100
IDC_BTN  equ 101

; 

    .data
      hInstance     dd 0
      origEditProc  dd 0
      hwndEdit      dd 0
      filter        dd 0
    .code

; 

EditProc proc hwnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    SWITCH uMsg

      CASE WM_CHAR

        .IF wParam == 13
          invoke CallWindowProc, origEditProc, hwnd, uMsg, wParam, lParam
        .ENDIF
        .IF filter
          .IF (wParam>="A" && wParam<="Z") || (wParam>="a" && wParam<="z")
            invoke CallWindowProc, origEditProc, hwnd, uMsg, wParam, lParam
          .ENDIF
        .ELSE
          .IF (wParam>="0" && wParam<="9")
            invoke CallWindowProc, origEditProc, hwnd, uMsg, wParam, lParam
          .ENDIF
        .ENDIF

      CASE WM_PASTE

        ; This effectively disables the WM_PASTE message,
        ; preventing the user from pasting characters.

      DEFAULT

        invoke CallWindowProc, origEditProc, hwnd, uMsg, wParam, lParam

    ENDSW
    ret

EditProc endp

; 

DlgProc proc hwndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hwndDlg, IDC_EDIT
        mov hwndEdit, eax
        invoke SetWindowLong, hwndEdit, GWL_WNDPROC, EditProc
        mov origEditProc, eax

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDC_BTN

            not filter
            invoke SetFocus, hwndEdit

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, 0

        ENDSW

      CASE WM_CLOSE

       invoke EndDialog, hwndDlg, 0

    ENDSW
    return 0

DlgProc endp

; 

start:

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    Dialog "TEST","MS Sans Serif",10, \
            WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
            2,0,0,100,80,1024
    DlgEdit WS_BORDER or ES_MULTILINE or ES_WANTRETURN or WS_TABSTOP or \
            WS_HSCROLL or WS_VSCROLL or ES_AUTOVSCROLL or ES_AUTOVSCROLL, \
            5,5,87,40,IDC_EDIT
    DlgButton "Switch Filter",WS_TABSTOP,26,53,45,10,IDC_BTN

    CallModalDialog hInstance,0,DlgProc,NULL

    exit

; 
end start
